﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Printing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        GridRowSizingOptions gridRowSizingOptions = new GridRowSizingOptions();
        double Height = double.NaN;

        public MainWindow()
        {
            InitializeComponent();
            this.syncgrid.Loaded += syncgrid_Loaded;            
        }
        void syncgrid_Loaded(object sender, RoutedEventArgs e)
        {
            syncgrid.PrintSettings.PrintManagerBase = new CustomPrintManager(this.syncgrid);
        }
      
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            syncgrid.PrintSettings.AllowPrintByDrawing = false;
            syncgrid.ShowPrintPreview();
            syncgrid.PrintSettings.AllowColumnWidthFitToPrintPage = true;            
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            syncgrid.Print();            
        }

    }
    public class CustomPrintManager : GridPrintManager
    {
        SfDataGrid dataGrid;
        GridRowSizingOptions gridRowSizingOptions = new GridRowSizingOptions();
        double Height = double.NaN;
        public CustomPrintManager(SfDataGrid grid)
            : base(grid)
        {
            dataGrid = grid;
        }

        protected override double GetRowHeight(object record, int rowindex)
        {
            if (record != null)
            {
                var actualrowindex = GridIndexResolver.ResolveToRowIndex(this.dataGrid, rowindex);
                if (this.dataGrid.GridColumnSizer.GetAutoRowHeight(actualrowindex, gridRowSizingOptions, out Height))
                {
                    return Height;
                }
            }
            return base.GetRowHeight(record, rowindex);
        }

    }
}
